package com.cch_lab.android.ware.sample.mymessageapi;

import android.app.Activity;
import android.app.ActionBar;
import android.app.Fragment;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.os.Build;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.cch_lab.android.ware.sample.mymessageapi.MyLayoutUtil.ButtonArray;
import com.cch_lab.android.ware.sample.mymessageapi.MyLayoutUtil.ButtonInfo;
import com.google.android.gms.wearable.MessageEvent;


public class MainActivity extends Activity implements View.OnClickListener {
    public static final String TAG = "MainActivity";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_activity);
        if (savedInstanceState == null) {
            //getFragmentManager().beginTransaction()
            //        .add(R.id.container, new PlaceholderFragment())
            //        .commit();
            final MyLayoutUtil.MyFragment mobileFragment = new MyLayoutUtil.MyFragment(
                    savedInstanceState,
                    "MessageApi Sample",                 //titleC
                    "wear にメッセージを送信します。",     //message
                    R.drawable.ic_launcher,              //iconRes;
                    new ButtonArray(
                        MainActivity.this,
                            "normal", "danger"),         //buttons
                    0,                                   //bgImage
                    Color.GREEN,                         //bgImage
                    Gravity.CENTER                       //gravity;
//                  Gravity.TOP | Gravity.LEFT           //gravity;
            );
            getFragmentManager().beginTransaction()
                    .add(R.id.container, mobileFragment)
                    .commit();
            mobileFragment.setOnActivityCreatedListener(new MyLayoutUtil.MyFragment.OnActivityCreatedListener() {
                @Override
                public void onActivityCreated(Bundle savedInstanceState) {
                    //ボタンのリスナとして、当該ActivityのonClickメソッドをバインド
                    mobileFragment.getButtons()[0].setOnClickListener(MainActivity.this);
                }
            });
        }

        //メッセージAPIユーティリティ初期化
        MyMessageApiUtil.init(
                this,
                new String[]{"mobile/normal", "mobile/danger", "wear/normal", "wear/danger"},
                new MyWearableListenerService.MyWearableListenerAction() {
                    @Override
                    public void onMessageReceived(final String messagePathQuery, final MessageEvent messageEvent) {
                        //Wearからのメッセージ受信時処理
                        Log.d(TAG, "message=" + new String(messageEvent.getData()) + "\n" + "query=" + messagePathQuery);
                        Toast.makeText(
                                MainActivity.this,
                                ("message=" + new String(messageEvent.getData()) + "\n"
                                        + "query=" + messagePathQuery),
                                Toast.LENGTH_LONG).show();
                    }
                });

        Log.d(TAG, "MyMessageApiUtil.init() executed");
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View v) {
        //Wearにメッセージ送信
        Button button = (Button)v;
        if (button.getText().equals("normal")) {
            MyMessageApiUtil.sendMessage("mobile/normal", "message from mobile at normal.");
        } else
        if (button.getText().equals("danger")) {
            MyMessageApiUtil.sendMessage("mobile/danger", "message from mobile at danger.");
        }
        Log.d(TAG, "mobile -> onClick  sendMessage()");
    }

//    /**
//     * A placeholder fragment containing a simple view.
//     */
//    public static class PlaceholderFragment extends Fragment {
//
//        public PlaceholderFragment() {
//        }
//
//        @Override
//        public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
//            View rootView = inflater.inflate(R.layout.main_fragment, container, false);
//            LinearLayout layout = (LinearLayout)rootView.findViewById(R.id.layout);
//            return rootView;
//        }
//    }
}
